[arch-commits] Commit in qemu/repos (7 files)

Anatol Pomozov anatolik at archlinux.org
Thu May 20 21:08:02 UTC 2021


    Date: Thursday, May 20, 2021 @ 21:08:01
  Author: anatolik
Revision: 415803

archrelease: copy trunk to staging-x86_64

Added:
  qemu/repos/staging-x86_64/
  qemu/repos/staging-x86_64/65-kvm.rules
    (from rev 415802, qemu/trunk/65-kvm.rules)
  qemu/repos/staging-x86_64/PKGBUILD
    (from rev 415802, qemu/trunk/PKGBUILD)
  qemu/repos/staging-x86_64/build-most-modules-statically-hack.diff
    (from rev 415802, qemu/trunk/build-most-modules-statically-hack.diff)
  qemu/repos/staging-x86_64/qemu-guest-agent.install
    (from rev 415802, qemu/trunk/qemu-guest-agent.install)
  qemu/repos/staging-x86_64/qemu-guest-agent.service
    (from rev 415802, qemu/trunk/qemu-guest-agent.service)
  qemu/repos/staging-x86_64/qemu.install
    (from rev 415802, qemu/trunk/qemu.install)

-----------------------------------------+
 65-kvm.rules                            |    1 
 PKGBUILD                                |  221 ++++++++++++++++++++++++++++++
 build-most-modules-statically-hack.diff |   40 +++++
 qemu-guest-agent.install                |    6 
 qemu-guest-agent.service                |    9 +
 qemu.install                            |    8 +
 6 files changed, 285 insertions(+)

Copied: qemu/repos/staging-x86_64/65-kvm.rules (from rev 415802, qemu/trunk/65-kvm.rules)
===================================================================
--- staging-x86_64/65-kvm.rules	                        (rev 0)
+++ staging-x86_64/65-kvm.rules	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1 @@
+KERNEL=="vhost-net", GROUP="kvm", MODE="0660", TAG+="uaccess", OPTIONS+="static_node=vhost-net"

Copied: qemu/repos/staging-x86_64/PKGBUILD (from rev 415802, qemu/trunk/PKGBUILD)
===================================================================
--- staging-x86_64/PKGBUILD	                        (rev 0)
+++ staging-x86_64/PKGBUILD	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1,221 @@
+# Maintainer: Tobias Powalowski <tpowa at archlinux.org>
+# Contributor: Sébastien "Seblu" Luttringer <seblu at seblu.net>
+
+pkgbase=qemu
+pkgname=(qemu qemu-headless qemu-arch-extra qemu-headless-arch-extra
+         qemu-block-{iscsi,rbd,gluster} qemu-guest-agent)
+pkgdesc="A generic and open source machine emulator and virtualizer"
+pkgver=6.0.0
+pkgrel=3
+arch=(x86_64)
+license=(GPL2 LGPL2.1)
+url="https://wiki.qemu.org/"
+_headlessdeps=(seabios gnutls libpng libaio numactl libnfs
+               lzo snappy curl vde2 libcap-ng spice libcacard usbredir libslirp
+               libssh zstd liburing ndctl dtc fuse3)
+depends=(virglrenderer sdl2 vte3 libpulse libjack.so brltty "${_headlessdeps[@]}")
+makedepends=(spice-protocol python ceph libiscsi glusterfs python-sphinx xfsprogs ninja)
+source=(https://download.qemu.org/qemu-$pkgver.tar.xz{,.sig}
+        build-most-modules-statically-hack.diff
+        qemu-guest-agent.service
+        65-kvm.rules)
+sha512sums=('ee3ff00aebec4d8891d2ff6dabe4e667e510b2a4fe3f6190aa34673a91ea32dcd2db2e9bf94c2f1bf05aa79788f17cfbbedc6027c0988ea08a92587b79ee05e4'
+            'SKIP'
+            '8721068fb968dbae62ceff71aa46eb4c2452c7fde95b87396b439f2f927ea84d2ee2c512264a9f28a5ccaf3096aacce052cebf209aaffd62a201b5bafb512002'
+            '269c0f0bacbd06a3d817fde02dce26c99d9f55c9e3b74bb710bd7e5cdde7a66b904d2eb794c8a605bf9305e4e3dee261a6e7d4ec9d9134144754914039f176e4'
+            'bdf05f99407491e27a03aaf845b7cc8acfa2e0e59968236f10ffc905e5e3d5e8569df496fd71c887da2b5b8d1902494520c7da2d3a8258f7fd93a881dd610c99')
+validpgpkeys=('CEACC9E15534EBABB82D3FA03353C9CEF108B584') # Michael Roth <flukshun at gmail.com>
+
+case $CARCH in
+  i?86) _corearch=i386 ;;
+  x86_64) _corearch=x86_64 ;;
+esac
+
+prepare() {
+  mkdir build-{full,headless}
+  mkdir -p extra-arch-{full,headless}/usr/{bin,share/qemu}
+
+  cd qemu-$pkgver
+  # https://bugs.launchpad.net/qemu/+bug/1910696
+  # the patch comes from https://salsa.debian.org/qemu-team/qemu/-/blob/master/debian/patches/build-most-modules-statically-hack.diff
+  patch -p1 < ../build-most-modules-statically-hack.diff
+}
+
+build() {
+  _build full \
+    --audio-drv-list="pa alsa sdl jack"
+
+  _build headless \
+    --audio-drv-list= \
+    --disable-sdl \
+    --disable-gtk \
+    --disable-vte \
+    --disable-brlapi \
+    --disable-opengl \
+    --disable-virglrenderer
+}
+
+_build() (
+  cd build-$1
+
+  ../${pkgname}-${pkgver}/configure \
+    --prefix=/usr \
+    --sysconfdir=/etc \
+    --localstatedir=/var \
+    --libexecdir=/usr/lib/qemu \
+    --smbd=/usr/bin/smbd \
+    --enable-modules \
+    --enable-sdl \
+    --enable-slirp=system \
+    --enable-xfsctl \
+    "${@:2}"
+
+  ninja
+)
+
+package_qemu() {
+  optdepends=('qemu-arch-extra: extra architectures support')
+  provides=(qemu-headless)
+  conflicts=(qemu-headless)
+  replaces=(qemu-kvm)
+
+  _package full
+}
+
+package_qemu-headless() {
+  pkgdesc="QEMU without GUI"
+  depends=("${_headlessdeps[@]}")
+  optdepends=('qemu-headless-arch-extra: extra architectures support')
+
+  _package headless
+}
+
+_package() {
+  optdepends+=('samba: SMB/CIFS server support'
+               'qemu-block-iscsi: iSCSI block support'
+               'qemu-block-rbd: RBD block support'
+               'qemu-block-gluster: glusterfs block support')
+  install=qemu.install
+  options=(!strip !emptydirs)
+
+  DESTDIR="$pkgdir" ninja -C build-$1 install "${@:2}"
+
+  # systemd stuff
+  install -Dm644 65-kvm.rules "$pkgdir/usr/lib/udev/rules.d/65-kvm.rules"
+
+  # remove conflicting /var/run directory
+  cd "$pkgdir"
+  rm -r var
+
+  cd usr/lib
+
+  # bridge_helper needs suid
+  # https://bugs.archlinux.org/task/32565
+  chmod u+s qemu/qemu-bridge-helper
+
+  # remove split block modules
+  rm qemu/block-{iscsi,rbd,gluster}.so
+
+  cd ../bin
+
+  # remove extra arch
+  for _bin in qemu-*; do
+    [[ -f $_bin ]] || continue
+
+    case ${_bin#qemu-} in
+      # guest agent
+      ga) rm "$_bin"; continue ;;
+
+      # tools
+      edid|img|io|keymap|nbd|pr-helper|storage-daemon) continue ;;
+
+      # core emu
+      system-${_corearch}) continue ;;
+    esac
+
+    mv "$_bin" "$srcdir/extra-arch-$1/usr/bin"
+  done
+
+  cd ../share/qemu
+  for _blob in *; do
+    [[ -f $_blob ]] || continue
+
+    case $_blob in
+      # provided by seabios package
+      bios.bin|bios-256k.bin|vgabios-cirrus.bin|vgabios-qxl.bin|\
+      vgabios-stdvga.bin|vgabios-vmware.bin|vgabios-virtio.bin|vgabios-bochs-display.bin|\
+      vgabios-ramfb.bin) rm "$_blob"; continue ;;
+
+      # provided by edk2-ovmf package
+      edk2-*) rm "$_blob"; continue ;;
+
+      # iPXE ROMs
+      efi-*|pxe-*) continue ;;
+
+      # core blobs
+      bios-microvm.bin|kvmvapic.bin|linuxboot*|multiboot.bin|sgabios.bin|vgabios*) continue ;;
+
+      # Trace events definitions
+      trace-events*) continue ;;
+    esac
+
+    mv "$_blob" "$srcdir/extra-arch-$1/usr/share/qemu"
+  done
+
+  # provided by edk2-ovmf package
+  rm -r firmware
+
+  cd ..
+  if [ "$1" = headless ]; then rm -r {applications,icons}; fi
+}
+
+package_qemu-arch-extra() {
+  pkgdesc="QEMU for foreign architectures"
+  depends=(qemu)
+  provides=(qemu-headless-arch-extra)
+  conflicts=(qemu-headless-arch-extra)
+  options=(!strip)
+
+  mv extra-arch-full/usr "$pkgdir"
+}
+
+package_qemu-headless-arch-extra() {
+  pkgdesc="QEMU without GUI, for foreign architectures"
+  depends=(qemu-headless)
+  options=(!strip)
+
+  mv extra-arch-headless/usr "$pkgdir"
+}
+
+package_qemu-block-iscsi() {
+  pkgdesc="QEMU iSCSI block module"
+  depends=(glib2 libiscsi)
+
+  install -D build-full/block-iscsi.so "$pkgdir/usr/lib/qemu/block-iscsi.so"
+}
+
+package_qemu-block-rbd() {
+  pkgdesc="QEMU RBD block module"
+  depends=(glib2 ceph-libs)
+
+  install -D build-full/block-rbd.so "$pkgdir/usr/lib/qemu/block-rbd.so"
+}
+
+package_qemu-block-gluster() {
+  pkgdesc="QEMU GlusterFS block module"
+  depends=(glib2 glusterfs)
+
+  install -D build-full/block-gluster.so "$pkgdir/usr/lib/qemu/block-gluster.so"
+}
+
+package_qemu-guest-agent() {
+  pkgdesc="QEMU Guest Agent"
+  depends=(gcc-libs glib2 libudev.so liburing)
+  install=qemu-guest-agent.install
+
+  install -D build-full/qga/qemu-ga "$pkgdir/usr/bin/qemu-ga"
+  install -Dm644 qemu-guest-agent.service "$pkgdir/usr/lib/systemd/system/qemu-guest-agent.service"
+  install -Dm755 "$srcdir/qemu-$pkgver/scripts/qemu-guest-agent/fsfreeze-hook" "$pkgdir/etc/qemu/fsfreeze-hook"
+}
+
+# vim:set ts=2 sw=2 et:

Copied: qemu/repos/staging-x86_64/build-most-modules-statically-hack.diff (from rev 415802, qemu/trunk/build-most-modules-statically-hack.diff)
===================================================================
--- staging-x86_64/build-most-modules-statically-hack.diff	                        (rev 0)
+++ staging-x86_64/build-most-modules-statically-hack.diff	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1,40 @@
+From: Michael Tokarev <mjt at tls.msk.ru>
+Subject: build most modules statically (hack)
+
+This hack makes the build procedure to build most modules statically,
+except block and gui modules which goes into their own packages.
+The rest are built into the executables directly in order to make
+qemu-system-common package (where all other modules goes) to be
+more-or-less version-independent.
+
+There's little reason to build these as modules or to ship them in
+separate packages.
+
+diff --git a/meson.build b/meson.build
+index e3386196ba..a28f7d10f1 100644
+--- a/meson.build
++++ b/meson.build
+@@ -1587,13 +1587,19 @@ softmmu_mods = []
+ foreach d, list : modules
+   foreach m, module_ss : list
+     if enable_modules and targetos != 'windows'
+-      module_ss = module_ss.apply(config_all, strict: false)
+-      sl = static_library(d + '-' + m, [genh, module_ss.sources()],
+-                          dependencies: [modulecommon, module_ss.dependencies()], pic: true)
++      module_dn = module_ss.apply(config_all, strict: false)
++      sl = static_library(d + '-' + m, [genh, module_dn.sources()],
++                          dependencies: [modulecommon, module_dn.dependencies()], pic: true)
+       if d == 'block'
+         block_mods += sl
+       else
+-        softmmu_mods += sl
++        # we only build 2 non-block modules as modules: it is the gui part
++        if d + '-' + m in [ 'ui-gtk', 'ui-sdl', 'audio-pa' ]
++          softmmu_mods += sl
++        else
++          warning('Compiling module statically: ' + d + '-' + m)
++          softmmu_ss.add_all(module_ss)
++        endif
+       endif
+     else
+       if d == 'block'

Copied: qemu/repos/staging-x86_64/qemu-guest-agent.install (from rev 415802, qemu/trunk/qemu-guest-agent.install)
===================================================================
--- staging-x86_64/qemu-guest-agent.install	                        (rev 0)
+++ staging-x86_64/qemu-guest-agent.install	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1,6 @@
+post_upgrade() {
+    echo "qemu-ga.service was renamed to qemu-guest-agent.service"
+    echo "You might want to switch to the new service name:"
+    echo "# systemctl disable qemu-ga.service"
+    echo "# systemctl enable qemu-guest-agent.service"
+}

Copied: qemu/repos/staging-x86_64/qemu-guest-agent.service (from rev 415802, qemu/trunk/qemu-guest-agent.service)
===================================================================
--- staging-x86_64/qemu-guest-agent.service	                        (rev 0)
+++ staging-x86_64/qemu-guest-agent.service	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1,9 @@
+[Unit]
+Description=QEMU Guest Agent
+ConditionPathExists=/dev/virtio-ports/org.qemu.guest_agent.0
+
+[Service]
+ExecStart=/usr/bin/qemu-ga
+
+[Install]
+WantedBy=multi-user.target

Copied: qemu/repos/staging-x86_64/qemu.install (from rev 415802, qemu/trunk/qemu.install)
===================================================================
--- staging-x86_64/qemu.install	                        (rev 0)
+++ staging-x86_64/qemu.install	2021-05-20 21:08:01 UTC (rev 415803)
@@ -0,0 +1,8 @@
+# Arg 1:  the new package version
+post_install() {
+  # trigger events on modules files when already loaded
+  for _f in /sys/devices/virtual/misc/vhost-net; do
+    [[ -e "$_f" ]] &&  udevadm trigger "$_f"
+  done
+  :
+}



More information about the arch-commits mailing list